diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 2c22886c..b837e7a1 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -1775,119 +2501,56 @@ class SquadService extends Actor {
     toMember.Armor = armor
   }
 
-  def UpdateSquadList(faction : PlanetSideEmpire.Value): Unit = {
-    val factionListings = publishedLists(faction)
-    SquadEvents.publish(
-      SquadServiceResponse(s"/$faction/Squad", SquadResponse.InitList(factionListings.toVector))
-    )
-  }
-
-  def UpdateSquadList(squad : Squad, changes : SquadInfo) : Unit = {
-    UpdateSquadList(squad, Some(changes))
-  }
-
-  def UpdateSquadListWhenListed(squad : Squad, changes : SquadInfo) : Unit = {
-    UpdateSquadListWhenListed(squad, Some(changes))
-  }
-
-  def UpdateSquadListWhenListed(squad : Squad, changes : Option[SquadInfo]) : Unit = {
-    if(squad.Listed || squad.Size > 1) {
-      UpdateSquadList(squad, changes)
-    }
-  }
-
-  def UpdateSquadList(squad : Squad, changes : Option[SquadInfo]) : Unit = {
-    val faction = squad.Faction
-    val factionListings = publishedLists(faction)
-    factionListings.find(info => {
-      info.squad_guid match {
-        case Some(sguid) => sguid == squad.GUID
-        case _ => false
-      }
-    }) match {
-      case Some(listedSquad) =>
-        val index = factionListings.indexOf(listedSquad)
-        changes match {
-          case Some(changedFields) =>
-            //squad information update
-            log.info(s"Squad will be updated")
-            factionListings(index) = SquadService.SquadList.Publish(squad)
-            SquadEvents.publish(
-              SquadServiceResponse(s"/$faction/Squad", SquadResponse.UpdateList(Seq((index, changedFields))))
-            )
+  /**
+    * Display the indicated waypoint.<br>
+    * <br>
+    * Despite the name, no waypoints are actually "added."
+    * All of the waypoints constantly exist as long as the squad to which they are attached exists.
+    * They are merely "activated" and "deactivated."
+    * @see `SquadWaypointRequest`
+    * @see `WaypointInfo`
+    * @param guid the squad's unique identifier
+    * @param waypointType the type of the waypoint as an integer;
+    *                     0-4 are squad waypoints;
+    *                     5 is the squad leader's experience waypoint
+    * @param info information about the waypoint, as was reported by the client's packet
+    * @return the waypoint data, if the waypoint type is changed
+    */
+  def AddWaypoint(guid : PlanetSideGUID, waypointType : Int, info : WaypointInfo) : Option[WaypointData] = {
+    squadFeatures.get(guid) match {
+      case Some(features) =>
+        features.Waypoints.lift(waypointType) match {
+          case Some(point) =>
+            point.zone_number = info.zone_number
+            point.pos = info.pos
+            Some(point)
           case None =>
-            //remove squad from listing
-            log.info(s"Squad will be removed")
-            factionListings.remove(index)
-            SquadEvents.publish(
-              //SquadServiceResponse(s"$faction/Squad", SquadResponse.RemoveFromList(Seq(index)))
-              SquadServiceResponse(s"/$faction/Squad", SquadResponse.InitList(factionListings.toVector))
-            )
+            log.error(s"no squad waypoint $waypointType found")
+            None
         }
       case None =>
-        //first time being published
-        log.info(s"Squad will be introduced")
-        factionListings += SquadService.SquadList.Publish(squad)
-        SquadEvents.publish(
-          SquadServiceResponse(s"/$faction/Squad", SquadResponse.InitList(factionListings.toVector))
-        )
-    }
-  }
-
-  def InitSquadDetail(squad : Squad) : Unit = {
-    InitSquadDetail(squad.GUID, squad.Membership.map { member => member.CharId }, squad)
-  }
-
-  def InitSquadDetail(guid : PlanetSideGUID, squad : Squad) : Unit = {
-    InitSquadDetail(guid, squad.Membership.map { member => member.CharId }, squad)
-  }
-
-  def InitSquadDetail(guid : PlanetSideGUID, toMembers : Iterable[Long], squad : Squad) : Unit = {
-    val output = SquadResponse.Detail(guid, SquadService.Detail.Publish(squad))
-    toMembers.foreach { charId => SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", output)) }
-  }
-
-  def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad) : Unit = {
-    UpdateSquadDetail(guid, squad, SquadService.Detail.Publish(squad))
-  }
-
-  def UpdateSquadDetail(squad : Squad, details : SquadDetail) : Unit = {
-    UpdateSquadDetail(squad.GUID, squad.Membership.map { member => member.CharId }, details)
-  }
-
-  def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad, details : SquadDetail) : Unit = {
-    UpdateSquadDetail(guid, squad.Membership.map { member => member.CharId }, details)
-  }
-
-  def UpdateSquadDetail(guid : PlanetSideGUID, toMembers : Iterable[Long], details : SquadDetail) : Unit = {
-    if(toMembers.nonEmpty) {
-      val output = SquadResponse.Detail(guid, details)
-      toMembers.foreach { charId => SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", output)) }
-    }
-  }
-
-  def AddWaypoint(guid : PlanetSideGUID, waypointType : Int, info : WaypointInfo) : Option[WaypointData] = {
-    squadFeatures(guid).Waypoints.lift(waypointType) match {
-      case Some(point) =>
-        //update the waypoint
-        log.debug(s"rendering squad waypoint $waypointType for squad #${guid.guid}")
-        point.zone_number = info.zone_number
-        point.pos = info.pos
-        Some(point)
-      case _ =>
-        log.warn(s"no squad waypoint $waypointType found")
+        log.error(s"no squad waypoint $waypointType found")
         None
     }
   }
 
+  /**
+    * Hide the indicated waypoint.
+    * Unused waypoints are marked by having a non-zero z-coordinate.<br>
+    * <br>
+    * Despite the name, no waypoints are actually "removed."
+    * All of the waypoints constantly exist as long as the squad to which they are attached exists.
+    * They are merely "activated" and "deactivated."
+    * @param guid the squad's unique identifier
+    * @param waypointType the type of the waypoint as an integer;
+    *                     0-4 are squad waypoints;
+    *                     5 is the squad leader's experience waypoint
+    */
   def RemoveWaypoint(guid : PlanetSideGUID, waypointType : Int) : Unit = {
     squadFeatures.get(guid) match {
       case Some(features) =>
         features.Waypoints.lift(waypointType) match {
           case Some(point) =>
-            //update the waypoint
-            log.debug(s"removing squad waypoint $waypointType for squad #${guid.guid}")
-            point.zone_number = 1
             point.pos = Vector3.z(1)
           case _ =>
             log.warn(s"no squad waypoint $waypointType found")
@@ -1897,104 +2560,301 @@ class SquadService extends Actor {
     }
   }
 
+  /**
+    * Dispatch all of the information about a given squad's waypoints to a user.
+    * @param toCharId the player to whom the waypoint data will be dispatched
+    * @param guid the squad's unique identifier
+    */
   def InitWaypoints(toCharId : Long, guid : PlanetSideGUID) : Unit = {
     squadFeatures.get(guid) match {
       case Some(features) =>
         val squad = features.Squad
         val vz1 = Vector3.z(value = 1)
         val list = features.Waypoints
-        SquadEvents.publish(
-          SquadServiceResponse(s"/$toCharId/Squad", SquadResponse.InitWaypoints(squad.Leader.CharId,
+        Publish(
+          toCharId, SquadResponse.InitWaypoints(squad.Leader.CharId,
             list.zipWithIndex.collect { case (point, index) if point.pos != vz1 =>
               (index, WaypointInfo(point.zone_number, point.pos), 1)
             }
-          ))
+          )
         )
       case None => ;
     }
   }
 
-  def indirectInviteResp(bid : IndirectInvite, player : Player, invitedPlayer : Long, invitingPlayer : Long, name : String) : Boolean = {
-    HandleBidForRole(bid, player)
+  def LeaveService(charId : String, sender : ActorRef) : Unit = {
+    LeaveService(charId.toLong, sender)
   }
 
-  def altIndirectInviteResp(bid : IndirectInvite, player : Player, invitedPlayer : Long, invitingPlayer : Long, name : String) : Boolean = {
-    SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), player.Name, false, Some(None))))
-    HandleBidForRole(bid, player)
+  def LeaveService(charId : Long, sender : ActorRef) : Unit = {
+    refused.remove(charId)
+    continueToMonitorDetails.remove(charId)
+    RemoveAllInvitesWithPlayer(charId)
+    val pSquadOpt = GetParticipatingSquad(charId)
+    val lSquadOpt = GetLeadingSquad(charId, pSquadOpt)
+    pSquadOpt match {
+      //member of the squad; leave the squad
+      case Some(squad) =>
+        val size = squad.Size
+        SquadEvents.unsubscribe(UserEvents(charId), s"/${squadFeatures(squad.GUID).ToChannel}/Squad")
+        UserEvents.remove(charId)
+        lSquadOpt match {
+          case Some(_) =>
+            //leader of a squad; the squad will be disbanded
+            PanicDisbandSquad(squad, squad.Membership.collect { case member if member.CharId > 0 && member.CharId != charId => member.CharId })
+          case None if size == 2 =>
+            //one of the last two members of a squad; the squad will be disbanded
+            PanicDisbandSquad(squad, squad.Membership.collect { case member if member.CharId > 0 && member.CharId != charId => member.CharId })
+          case None =>
+            //not the leader of the squad; tell other members that we are leaving
+            PanicLeaveSquad(charId, squad, squad.Membership.zipWithIndex.find { case (_member, _) => _member.CharId == charId })
+        }
+      case None =>
+        //not a member of any squad; nothing to do here
+        UserEvents.remove(charId)
+    }
+    SquadEvents.unsubscribe(sender) //just to make certain
   }
 
-  def InviteResponseTemplate(indirectVacancyFunc : (IndirectInvite, Player, Long, Long, String) => Boolean)(targetInvite : Invitation, actualInvite : Option[Invitation], invitedPlayer : Long, invitingPlayer : Long, name : String) : Unit = {
-    if(actualInvite.contains(targetInvite)) {
-      //immediately respond
-      targetInvite match {
-        case VacancyInvite(charId, _name, _) =>
-          SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, charId, Some(invitedPlayer), _name, false, Some(None))))
-          SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), _name, true, Some(None))))
+  /**
+    * Dispatch a message entailing the composition of this squad
+    * and focus on any specific aspects of it, purported as being changed recently.
+    * @see `SquadInfo`
+    * @see `UpdateSquadList(Squad, Option[SquadInfo])`
+    * @param squad the squad
+    * @param changes the highlighted aspects of the squad;
+    *                these "changes" do not have to reflect the actual squad but are related to the contents of the message
+    */
+  private def UpdateSquadList(squad : Squad, changes : SquadInfo) : Unit = {
+    UpdateSquadList(squad, Some(changes))
+  }
 
-        case _bid @ IndirectInvite(player, _) =>
-          indirectVacancyFunc(_bid, player, invitedPlayer, invitingPlayer, name)
+  /**
+    * Dispatch a message entailing the composition of this squad when that squad is publicly available
+    * and focus on any specific aspects of it, purported as being changed recently.
+    * @see `SquadInfo`
+    * @see `UpdateSquadList(Squad, Option[SquadInfo])`
+    * @param features the related information about the squad
+    * @param changes the highlighted aspects of the squad;
+    *                these "changes" do not have to reflect the actual squad but are related to the contents of the message
+    */
+  private def UpdateSquadListWhenListed(features : SquadFeatures, changes : SquadInfo) : Unit = {
+    UpdateSquadListWhenListed(features, Some(changes))
+  }
 
-        case _bid @ SpontaneousInvite(player) =>
-          val bidInvitingPlayer = _bid.InviterCharId
-          SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, bidInvitingPlayer, Some(invitedPlayer), player.Name, false, Some(None))))
-          SquadEvents.publish(SquadServiceResponse(s"/$bidInvitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(bidInvitingPlayer), player.Name, true, Some(None))))
+  /**
+    * Dispatch a message entailing the composition of this squad when that squad is publicly available
+    * and focus on any specific aspects of it, purported as being changed recently.
+    * The only requirement is that the squad is publicly available for recruitment ("listed").
+    * @see `SquadInfo`
+    * @see `UpdateSquadList(Squad, Option[SquadInfo])`
+    * @param features the related information about the squad
+    * @param changes the optional highlighted aspects of the squad;
+    *                these "changes" do not have to reflect the actual squad but are related to the contents of the message
+    */
+  private def UpdateSquadListWhenListed(features : SquadFeatures, changes : Option[SquadInfo]) : Unit = {
+    val squad = features.Squad
+    if(features.Listed) {
+      UpdateSquadList(squad, changes)
+    }
+  }
 
-        case _bid @ BidForRole(player, _, _) =>
-          HandleBidForRole(_bid, player)
+  /**
+    * Dispatch a message entailing the composition of this squad
+    * and focus on any specific aspects of it, purported as being changed recently.<br>
+    * <br>
+    * What sort of message is dispatched is not only based on the input parameters
+    * but also on the state of previously listed squad information.
+    * Listed squad information is queued when it is first published, organized first by faction affinity, then by chronology.
+    * The output is first determinate on whether the squad had previously been listed as available.
+    * If so, it will either update its data to all valid faction associated entities with the provided changed data;
+    * or, it will be removed from the list of available squads, if there is no provided change data.
+    * If the squad can not be found,
+    * the change data, whatever it is, is unimportant, and the squad will be listed in full for the first time.<br>
+    * <br>
+    * When a squad is first introduced to the aforementioned list,
+    * thus first being published to all faction-associated parties,
+    * the entirety of the squad list for that faction will be updated in one go.
+    * It is not necessary to do this, but doing so saves index and unique squad identifier management
+    * at the cost of the size of the packet to be dispatched.
+    * When a squad is removed to the aforementioned list,
+    * the same process occurs where the full list for that faction affiliation is sent as an update.
+    * The procedure for updating individual squad fields is precise and targeted,
+    * and has been or should be prepared in advance by the caller to this method.
+    * As a consequence, when updating the entry for that squad,
+    * the information used as the update does not necessarily reflect the actual information currently in the squad.
+    * @see `SquadResponse.InitList`
+    * @see `SquadResponse.UpdateList`
+    * @see `SquadService.SquadList.Publish`
+    * @param squad the squad
+    * @param changes the optional highlighted aspects of the squad;
+    *                these "changes" do not have to reflect the actual squad but are related to the contents of the message
+    */
+  def UpdateSquadList(squad : Squad, changes : Option[SquadInfo]) : Unit = {
+    val guid = squad.GUID
+    val faction = squad.Faction
+    val factionListings = publishedLists(faction)
+    factionListings.find(_ == guid) match {
+      case Some(listedSquad) =>
+        val index = factionListings.indexOf(listedSquad)
+        changes match {
+          case Some(changedFields) =>
+            //squad information update
+            Publish(faction, SquadResponse.UpdateList(Seq((index, changedFields))))
+          case None =>
+            //remove squad from listing
+            factionListings.remove(index)
+            //Publish(faction, SquadResponse.RemoveFromList(Seq(index)))
+            Publish(faction, SquadResponse.InitList(PublishedLists(factionListings)))
+        }
+      case None =>
+        //first time being published
+        factionListings += guid
+        Publish(faction, SquadResponse.InitList(PublishedLists(factionListings)))
+    }
+  }
 
-        case InviteForRole(charId, _name, _, _) =>
-          SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), _name, false, Some(None))))
+  /**
+    * Dispatch a message entailing the composition of this squad.
+    * This is considered the first time this information will be dispatched to any relevant observers
+    * so the details of the squad will be updated in full and be sent to all relevant observers,
+    * namely, all the occupants of the squad.
+    * External observers are ignored.
+    * @see `InitSquadDetail(PlanetSideGUID, Iterable[Long], Squad)`
+    * @param squad the squad
+    */
+  def InitSquadDetail(squad : Squad) : Unit = {
+    InitSquadDetail(
+      squad.GUID,
+      squad.Membership.collect { case member if member.CharId > 0 => member.CharId },
+      squad
+    )
+  }
 
-        case ProximityInvite(charId, _name, _) =>
-          SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), _name, false, Some(None))))
+  /**
+    * Dispatch an intial message entailing the strategic information and the composition of this squad.
+    * The details of the squad will be updated in full and be sent to all indicated observers.
+    * @see `SquadService.Detail.Publish`
+    * @param guid the unique squad identifier to be used when composing the details for this message
+    * @param to the unique character identifier numbers of the players who will receive this message
+    * @param squad the squad from which the squad details shall be composed
+    */
+  def InitSquadDetail(guid : PlanetSideGUID, to : Iterable[Long], squad : Squad) : Unit = {
+    val output = SquadResponse.Detail(guid, SquadService.Detail.Publish(squad))
+    to.foreach { Publish(_, output) }
+  }
 
-        case _ =>
-          log.warn(s"AddInviteAndRespond: can not parse discovered unhandled invitation type - $targetInvite")
+  /**
+    * Send a message entailing the strategic information and the composition of the squad to the existing members of the squad.
+    * @see `SquadService.Detail.Publish`
+    * @see `UpdateSquadDetail(PlanetSideGUID, PlanetSideGUID, List[Long], SquadDetail)`
+    * @param squad the squad
+    */
+  def UpdateSquadDetail(squad : Squad) : Unit = {
+    UpdateSquadDetail(
+      squad.GUID,
+      squad.GUID,
+      Nil,
+      SquadService.Detail.Publish(squad)
+    )
+  }
+
+  /**
+    * Send a message entailing the strategic information and the composition of the squad to the existing members of the squad.
+    * Rather than using the squad's existing unique identifier number,
+    * a meaningful substitute identifier will be employed in the message.
+    * The "meaningful substitute" is usually `PlanetSideGUID(0)`
+    * which indicates the local non-squad squad data on the client of a squad leader.
+    * @see `SquadService.Detail.Publish`
+    * @see `UpdateSquadDetail(PlanetSideGUID, PlanetSideGUID, List[Long], SquadDetail)`
+    * @param squad the squad
+    */
+  def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad) : Unit = {
+    UpdateSquadDetail(
+      guid,
+      squad.GUID,
+      Nil,
+      SquadService.Detail.Publish(squad)
+    )
+  }
+
+  /**
+    * Send Send a message entailing some of the strategic information and the composition to the existing members of the squad.
+    * @see `SquadResponse.Detail`
+    * @see `UpdateSquadDetail(PlanetSideGUID, PlanetSideGUID, List[Long], SquadDetail)`
+    * @param guid the unique identifier number of the squad
+    * @param details the squad details to be included in the message
+    */
+  def UpdateSquadDetail(guid : PlanetSideGUID, details : SquadDetail) : Unit = {
+    UpdateSquadDetail(
+      guid,
+      guid,
+      Nil,
+      details
+    )
+  }
+
+  /**
+    * Send a message entailing some of the strategic information and the composition to the existing members of the squad.
+    * Also send the same information to any users who are watching the squad, potentially for want to join it.
+    * The squad-specific message is contingent on finding the squad's features using the unique identifier number
+    * and, from that, reporting to the specific squad's messaging channel.
+    * Anyone watching the squad will always be updated the given details.
+    * @see `DisplaySquad`
+    * @see `Publish`
+    * @see `SquadDetail`
+    * @see `SquadResponse.Detail`
+    * @param guid the unique squad identifier number to be used for the squad detail message
+    * @param toGuid the unique squad identifier number indicating the squad broadcast channel name
+    * @param excluding the explicit unique character identifier numbers of individuals who should not receive the message
+    * @param details the squad details to be included in the message
+    */
+  def UpdateSquadDetail(guid : PlanetSideGUID, toGuid : PlanetSideGUID, excluding : Iterable[Long], details : SquadDetail) : Unit = {
+    val output = SquadResponse.Detail(guid, details)
+    squadFeatures.get(toGuid) match {
+      case Some(features) =>
+        Publish(features.ToChannel, output, excluding)
+      case _ => ;
+    }
+    continueToMonitorDetails
+      .collect { case (charId, sguid) if sguid == guid && !excluding.exists(_ == charId) =>
+        Publish(charId, output, Nil)
       }
-    }
   }
 
-  def AddInviteAndRespond(invitedPlayer : Long, targetInvite : Invitation, invitingPlayer : Long, name : String) : Unit = {
-    InviteResponseTemplate(indirectInviteResp)(
-      targetInvite,
-      AddInvite(invitedPlayer, targetInvite),
-      invitedPlayer,
-      invitingPlayer,
-      name
-    )
+  /**
+    * Transform a list of squad unique identifiers into a list of `SquadInfo` objects for updating the squad list window.
+    * @param faction the faction to which the squads belong
+    * @return a `Vector` of transformed squad data
+    */
+  def PublishedLists(faction : PlanetSideEmpire.Type) : Vector[SquadInfo] = {
+    PublishedLists(publishedLists(faction))
   }
-
-  def AltAddInviteAndRespond(invitedPlayer : Long, targetInvite : Invitation, invitingPlayer : Long, name : String) : Unit = {
-    InviteResponseTemplate(altIndirectInviteResp)(
-      targetInvite,
-      AddInvite(invitedPlayer, targetInvite),
-      invitedPlayer,
-      invitingPlayer,
-      name
-    )
-  }
-
-  def NextInviteAndRespond(invitedPlayer : Long) : Unit = {
-    NextInvite(invitedPlayer) match {
-      case Some(invite) =>
-        InviteResponseTemplate(indirectInviteResp)(
-          invite,
-          Some(invite),
-          invitedPlayer,
-          invite.InviterCharId,
-          invite.InviterName
-        )
-      case None => ;
-    }
+  /**
+    * Transform a list of squad unique identifiers into a list of `SquadInfo` objects for updating the squad list window.
+    * @param guids the list of squad unique identifier numbers
+    * @return a `Vector` of transformed squad data
+    */
+  def PublishedLists(guids : Iterable[PlanetSideGUID]) : Vector[SquadInfo] = {
+    guids.map {guid => SquadService.SquadList.Publish(squadFeatures(guid).Squad) }.toVector
   }
 }
 
 object SquadService {
+
+  /**
+    * Information necessary to display a specific map marker.
+    */
   class WaypointData() {
     var zone_number : Int = 1
     var pos : Vector3 = Vector3.z(1) //a waypoint with a non-zero z-coordinate will flag as not getting drawn
   }
 
+  /**
+    * The base of all objects that exist for the purpose of communicating invitation from one player to the next.
+    * @param char_id the inviting player's unique identifier number
+    * @param name the inviting player's name
+    */
   abstract class Invitation(char_id : Long, name : String) {
     def InviterCharId : Long = char_id
     def InviterName : String = name
@@ -2007,7 +2867,7 @@ object SquadService {
     * @param squad_guid the squad with the role
     * @param position the index of the role
     */
-  final case class BidForRole(player : Player, squad_guid : PlanetSideGUID, position : Int)
+  final case class RequestRole(player : Player, squad_guid : PlanetSideGUID, position : Int)
     extends Invitation(player.CharId, player.Name)
 
   /**
@@ -2050,7 +2910,7 @@ object SquadService {
     * @param squad_guid the squad with the role
     * @param position the index of the role
     */
-  final case class InviteForRole(char_id : Long, name : String, squad_guid : PlanetSideGUID, position : Int)
+  final case class LookingForSquadRoleInvite(char_id : Long, name : String, squad_guid : PlanetSideGUID, position : Int)
     extends Invitation(char_id, name)
 
   /**
@@ -2060,105 +2920,13 @@ object SquadService {
   final case class SpontaneousInvite(player : Player)
     extends Invitation(player.CharId, player.Name)
 
-  class SquadFeatures(val Squad : Squad) {
-    /**
-      * `initialAssociation` per squad is similar to "Does this squad want to recruit members?"
-      * The squad does not have to be flagged.
-      * Dispatches an `AssociateWithSquad` `SDAM` to the squad leader and ???
-      * and then a `SDDUM` that includes at least the squad owner name and char id.
-      * Dispatched only once when a squad is first listed
-      * or when the squad leader searches for recruits by proximity or for certain roles or by invite
-      * or when a spontaneous squad forms,
-      * whichever happens first.
-      * Additionally, the packets are also sent when the check is made when the continent is changed (or set).
-      */
-    private var initialAssociation : Boolean = true
-    /**
-      * na
-      */
-    private var switchboard : ActorRef = ActorRef.noSender
-    /**
-      * Waypoint data.
-      * The first four slots are used for squad waypoints.
-      * The fifth slot is used for the squad leader experience waypoint.
-      * @see `Start`
-      */
-    private var waypoints : Array[WaypointData] = Array[WaypointData]()
-    /**
-      * The particular position being recruited right at the moment.
-      * When `None`. no highlighted searches have been indicated.
-      * When a positive integer or 0, indicates distributed `InviteForRole` messages as recorded by `proxyInvites`.
-      * Only one position may bne actively recruited at a time in this case.
-      * When -1, indicates distributed `ProximityIvite` messages as recorded by `proxyInvites`.
-      * Previous efforts may or may not be forgotten if there is a switch between the two modes.
-      */
-    private var searchForRole : Option[Int] = None
-    /**
-      * Handle persistent data related to `ProximityInvite` and `InviteForRole` messages
-      */
-    private var proxyInvites : List[Long] = Nil
-    /**
-      * These useres rejected invitation to this squad.
-      * For the purposes of wide-searches for membership
-      * such as Looking For Squad checks and proximity invitation,
-      * the unique character identifier numbers in this list are skipped.
-      * Direct invitation requests from the non sqad member should remain functional.
-      */
-    private var refusedPlayers : List[Long] = Nil
-
-    def Start(implicit context : ActorContext) : SquadFeatures = {
-      switchboard = context.actorOf(Props[SquadSwitchboard], s"squad${Squad.GUID.guid}")
-      waypoints = Array.fill[WaypointData](5)(new WaypointData())
-      this
-    }
-
-    def Stop : SquadFeatures = {
-      switchboard ! akka.actor.PoisonPill
-      switchboard = Actor.noSender
-      waypoints = Array.empty
-      this
-    }
-
-    def InitialAssociation : Boolean = initialAssociation
-
-    def InitialAssociation_=(assoc : Boolean) : Boolean = {
-      initialAssociation = assoc
-      InitialAssociation
-    }
-
-    def Switchboard : ActorRef = switchboard
-
-    def Waypoints : Array[WaypointData] = waypoints
-
-    def SearchForRole : Option[Int] = searchForRole
-
-    def SearchForRole_=(role : Int) : Option[Int] = SearchForRole_=(Some(role))
-
-    def SearchForRole_=(role : Option[Int]) : Option[Int] = {
-      searchForRole = role
-      SearchForRole
-    }
-
-    def ProxyInvites : List[Long] = proxyInvites
-
-    def ProxyInvites_=(list : List[Long]) : List[Long] = {
-      proxyInvites = list
-      ProxyInvites
-    }
-
-    def Refuse : List[Long] = refusedPlayers
-
-    def Refuse_=(charId : Long) : List[Long] = {
-      Refuse_=(List(charId))
-    }
-
-    def Refuse_=(list : List[Long]) : List[Long] = {
-      refusedPlayers = list ++ refusedPlayers
-      Refuse
-    }
-  }
-
   object SquadList {
+    /**
+      * Produce complete squad information.
+      * @see `SquadInfo`
+      * @param squad the squad
+      * @return the squad's information to be used in the squad list
+      */
     def Publish(squad : Squad) : SquadInfo = {
       SquadInfo(
         squad.Leader.Name,
@@ -2172,6 +2940,12 @@ object SquadService {
   }
 
   object Detail {
+    /**
+      * Produce complete squad membership details.
+      * @see `SquadDetail`
+      * @param squad the squad
+      * @return the squad's information to be used in the squad's detail window
+      */
     def Publish(squad : Squad) : SquadDetail = {
       SquadDetail()
         .Field1(squad.GUID.guid)
@@ -2193,6 +2967,11 @@ object SquadService {
     }
   }
 
+  /**
+    * Clear the current detail about a squad's membership and replace it with a previously stored details.
+    * @param squad the squad
+    * @param favorite the loadout object
+    */
   def LoadSquadDefinition(squad : Squad, favorite : SquadLoadout) : Unit = {
     squad.Task = favorite.task
     squad.ZoneId = favorite.zone_id.getOrElse(squad.ZoneId)
